/*
 * Copyright (c) 1991, 1992 Nick Colonello 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 * 
*/
#include <stdio.h>
#include <malloc.h>
#include <rpc/rpc.h>
#include <rpcsvc/ether.h>

#define MAX_BYTES_PER_SEC (10000000/8)
void *etherproc_on_1();
void *etherproc_selectsrc_1();
void *etherproc_selectdst_1();
struct etherstat  *etherproc_getdata_1();

CLIENT *cl;
struct etherstat *stat,*oldstat;

ether_init(server)
char *server;
{
	void *result;
	struct addrmask addr;

	oldstat = (struct etherstat *)malloc(sizeof(struct etherstat));
	addr.a_mask = 0;
	addr.a_addr = 0;

	cl = clnt_create(server,ETHERSTATPROG,ETHERSTATVERS,"udp");
	if(cl == NULL) {
		printf("error doing create\n");
		clnt_pcreateerror(server);
		exit(1);
	}
	result = etherproc_on_1((void *)NULL,cl);
	if(result == NULL) {
		printf("error doing call on\n");
		clnt_perror(cl,server);
		exit(1);
	}
	result = etherproc_selectsrc_1(&addr,cl);
	if(result == NULL) {
		printf("error doing call selectsrc\n");
		clnt_perror(cl,server);
		exit(1);
	}
	result = etherproc_selectdst_1(&addr,cl);
	if(result == NULL) {
		printf("error doing call selectdst\n");
		clnt_perror(cl,server);
		exit(1);
	}
}

double ether_get_data()
{
	long t_sec,t_usec;
	double delta_bytes,delta_msec,bytes_per_sec,util;

	stat = etherproc_getdata_1((void *)NULL,cl);
	if(stat == NULL) {
		printf("error doing call getdata\n");
		exit(1);
	}
	delta_bytes = stat->e_bytes - oldstat->e_bytes;
	t_usec = stat->e_time.tv_usec - oldstat->e_time.tv_usec;
	t_sec = stat->e_time.tv_sec - oldstat->e_time.tv_sec ;
	if( t_usec < 0 ) {
		t_usec += 1000000;
		t_sec -= 1;
	}
	delta_msec = t_usec/1000 + t_sec * 1000 ;
	bytes_per_sec = delta_bytes * 1000 / delta_msec;
	util = bytes_per_sec  / MAX_BYTES_PER_SEC;

	*oldstat = *stat;
	/*fprintf(stderr,"%f\n",util*100);*/
	return(util);
}
