/* xep: Ethernet Packet-traffic watcher for X
 *		Release 1.00 Jan. 30, 1991
 *
 *		RPC stuff by Nick Colonello (ether*.c)
 *		X11 stuff by Luis Fernandes (main.c)
 *
 * Copyright (c) 1991, 1992  Nick Colonello & Luis Fernandes
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation. 
 *	
 *		Resources don't work, YET!!
 */
#include <stdio.h>

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/StripChart.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>

#include <X11/Xaw/Cardinals.h>

#define XtNserverName	"server"
#define XtCserverName	"Server"

char serverName[16];	/* server-name loaded into here by resource manager*/

static XtResource resources[] = {
	{
	XtNserverName, XtCserverName, 
	XtRString, sizeof(char *),
	(Cardinal)serverName, 
	XtRString,  "eagle"
	}
};

extern void GetVal(), Quit();
extern double ether_get_data();

Arg args[2];
Widget stripChart, topLevel;

#ifdef DEBUG
Widget box, label, quit;
#endif

main(argc, argv)
int argc;
char **argv;
{

	topLevel = XtInitialize("xep", "XEp", NULL, NULL, &argc, argv);

	XtGetApplicationResources(topLevel, (caddr_t) NULL, resources,
				XtNumber(resources), NULL, (Cardinal) 0);

#ifdef DEBUG
	box=XtCreateManagedWidget("box", boxWidgetClass, topLevel, NULL, ZERO);

	/* label holds value that represents percentage of total bandwidth 
	 * of EtherNet being used (the value plotted is scaled up)*/
	XtSetArg(args[0], XtNlabel, "0.00%%");
	label=XtCreateManagedWidget("label", labelWidgetClass, box, args, ONE);

	XtSetArg(args[0], XtNupdate, 5);	/* update widget every 5 seconds*/
	stripChart=XtCreateManagedWidget("stripChart", stripChartWidgetClass, 
				box, args, ONE);
	XtAddCallback(stripChart, XtNgetValue, GetVal, NULL);

#else

	XtSetArg(args[0], XtNupdate, 5);	/* update widget every 5 seconds*/
	stripChart=XtCreateManagedWidget("stripChart", stripChartWidgetClass, 
				topLevel, args, ONE);
	XtAddCallback(stripChart, XtNgetValue, GetVal, NULL);

#endif

#ifdef DEBUG
	quit=XtCreateManagedWidget("Quit", commandWidgetClass, box, NULL, ZERO);
	XtAddCallback(quit, XtNcallback, Quit, NULL);
#endif

	/* XtInitialize() will leave any other un-recognized options*/
	if(argv[1]) 
		strcpy(serverName, argv[1]);/* if a server name was provided*/
	else{
		fprintf(stderr,"Usage: %s [-toolkitoptions ...] servername\n", 
					argv[0]);
		exit(-1);
	}

#ifdef DEBUG
	fprintf(stderr,"%s: Server:%s\n",argv[0], serverName);
#endif

	ether_init(serverName);

	XtRealizeWidget(topLevel);
	XtMainLoop();
}

/*--------------------------------------------------------------------
 * GetVal, callback for the strip-chart widget that loads the pointer
 *		with the value passed from the ether_get_data function
 *
 *		passed: calling widget
 *				un-used pointer
 *				pointer into which display-value is loaded
 *		returns: nothing
 */
void
GetVal(widget,closure,value_ptr)
Widget widget;
XtPointer closure, value_ptr;
{
	char buf[16];
	double *value = (double *) value_ptr;

	*value=ether_get_data()*10;	/* scale it so every scale-line is 10 units*/
#ifdef DEBUG
	/* update value is a percentage of total bandwidth of EtherNet */
	sprintf(buf,"%5.2f%%", *value*10);	
	XtSetArg(args[0], XtNlabel, buf);
	XtSetValues(label, args, ONE);
#endif

}/* GetVal */

#ifdef DEBUG

/*--------------------------------------------------------------------
 * Quit, callback for the Quit button. Exits the application
 */
void Quit(w, client_data, call_data)
Widget w;
caddr_t client_data, call_data;
{

    exit(0);

}/* quit*/

#endif


